﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace NumericEditorPercentHandling
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            ultraNumericEditor1.NumericType = Infragistics.Win.UltraWinEditors.NumericType.Double;
            ultraNumericEditor1.FormatString = "###0.#0%";

            ultraNumericEditor1.BeforeExitEditMode += UltraNumericEditor1_BeforeExitEditMode;
            ultraNumericEditor1.BeforeEnterEditMode += UltraNumericEditor1_BeforeEnterEditMode;
        }

        private void UltraNumericEditor1_BeforeEnterEditMode(object sender, CancelEventArgs e)
        {
            double val = double.Parse(ultraNumericEditor1.Value.ToString());

            if (!double.IsNaN(val))
            {
                ultraNumericEditor1.Value = val * 100;
            }
        }

        private void UltraNumericEditor1_BeforeExitEditMode(object sender, Infragistics.Win.BeforeExitEditModeEventArgs e)
        {
            double val = double.Parse(ultraNumericEditor1.Value.ToString());

            if (!double.IsNaN(val))
            {
                ultraNumericEditor1.Value = val / 100;
            }
        }
    }
}
